<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */
namespace App\Http\Validators;

use App\Http\Base\Validation;

class ItempenyesuaianstokValidator extends Validation
{
    /**
    * this function will call before insert, you can custom as your business requirement
    * @param array $input
    * @return $this
    */
    public function beforeInsert($input){
		if(empty($input["itemId"])){
			array_push($this->error, ["itemId" => "cannot be null"]);
		}
		else{
			$lengthitemid = strlen($input["itemId"]);
			if($lengthitemid>19){
			array_push($this->error, ["itemid" => "value too long"]);
			}
		}
		$item= (new \App\Http\Models\ItemModel())
			->getQuery()->where("id","=",$input["itemId"])->first();
		if(empty($item)){
			array_push($this->error, ["itemId" => "invalid relation"]);
		}
		if(empty($input["penyesuaianStokId"])){
			array_push($this->error, ["penyesuaianStokId" => "cannot be null"]);
		}
		else{
			$lengthpenyesuaianstokid = strlen($input["penyesuaianStokId"]);
			if($lengthpenyesuaianstokid>19){
			array_push($this->error, ["penyesuaianstokid" => "value too long"]);
			}
		}
		$penyesuaianstok= (new \App\Http\Models\PenyesuaianstokModel())
			->getQuery()->where("id","=",$input["penyesuaianStokId"])->first();
		if(empty($penyesuaianstok)){
			array_push($this->error, ["penyesuaianStokId" => "invalid relation"]);
		}
		if(empty($input["quantity"])){
			array_push($this->error, ["quantity" => "cannot be null"]);
		}
		else{
			$lengthquantity = strlen($input["quantity"]);
			if($lengthquantity>10){
			array_push($this->error, ["quantity" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before update into database, you can custom as your business requirement
    * @param array $input
    * @param $id
    * @return $this
    */
    public function beforeUpdate($input,$id){
		if(empty($input["itemId"])){
			array_push($this->error, ["itemId" => "cannot be null"]);
		}
		else{
			$lengthitemid = strlen($input["itemId"]);
			if($lengthitemid>19){
			array_push($this->error, ["itemid" => "value too long"]);
			}
		}
		if(!empty($input["itemId"])){
		$item= (new \App\Http\Models\ItemModel())
			->getQuery()->where("id","=",$input["itemId"])->first();
		if(empty($item)){
			array_push($this->error, ["itemId" => "invalid relation"]);
		}
		}
		if(empty($input["penyesuaianStokId"])){
			array_push($this->error, ["penyesuaianStokId" => "cannot be null"]);
		}
		else{
			$lengthpenyesuaianstokid = strlen($input["penyesuaianStokId"]);
			if($lengthpenyesuaianstokid>19){
			array_push($this->error, ["penyesuaianstokid" => "value too long"]);
			}
		}
		if(!empty($input["penyesuaianStokId"])){
		$penyesuaianstok= (new \App\Http\Models\PenyesuaianstokModel())
			->getQuery()->where("id","=",$input["penyesuaianStokId"])->first();
		if(empty($penyesuaianstok)){
			array_push($this->error, ["penyesuaianStokId" => "invalid relation"]);
		}
		}
		if(empty($input["quantity"])){
			array_push($this->error, ["quantity" => "cannot be null"]);
		}
		else{
			$lengthquantity = strlen($input["quantity"]);
			if($lengthquantity>10){
			array_push($this->error, ["quantity" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before delete from database, you can custom as your business requirement
    * @param $id
    * @return $this
    */
    public function beforeDelete($id){
	return $this;

    }


}